// ESP32 L298N Dual H Bridge Stepper Motor Driver
/** carSpeedLeftPin = 23,  carLeft1Pin = 18,  carLeft2Pin = 5,
    carSpeedRightPin = 19, carRight1Pin = 15, carRight2Pin = 2
      void carBegin();  // in setup()
      void carSpeed();  // send the carLeftRight[0/1][0] speed values to the controller
      void carSpeedTo(uint8_t leftCycle, uint8_t rightCycle);  // speed up/down from the carLeftRight[0][] and carLeftRight[1][] values
      void carValues(const uint8_t cl, const uint8_t dl, const uint8_t cr, const uint8_t dr);  // set carLeftRight[2][3]: cycle l/r, direction l/r
           carValues(cl, dl, cr, dr)           :  VALUE SETTINGS
                     carSpeedLeftPin (cl  LEFT): carStop, 1 to carMaxCycle, carUnchanged
             carLeft1Pin/carLeft2Pin (dl  LEFT): carStop, carForward, carReverse, carUnchanged
                    carSpeedRightPin (cr RIGHT): carStop, 1 to carMaxCycle, carUnchanged
           carRight1Pin/carRight2Pin (dr RIGHT): carStop, carForward, carReverse, carUnchanged **/

#include <sCarL298N.h>
  //uint8_t speedLeftPin  = 23,  left1Pin = 18,  left2Pin = 5,
  //        speedRightPin = 19, right1Pin = 15, right2Pin = 2,
  //        freq = 30000, channelLeft = 0, channelRicht = 1, resolution = 8,
  //        minCycle = 160, maxCycle = 250, _delay = 20 /* usec */;

void setup() {
  Serial.begin(115200);
  Serial.println("\n...\n");
  //  carBegin(speedLeftPin, left1Pin, left2Pin,
  //           speedRightPin, right1Pin, right2Pin,
  //           freq, channelLeft, channelRicht, resolution,
  //           minCycle, maxCycle, _delay);
  carBegin();
  // TESTING 0 //
  carValues(carMaxCycle, carForward, carMinCycle, carForward);  // set leftMAX/rightMIN rotations
  carSpeed();  // start
  delay(50);  
  carSpeedTo(carMinCycle, carMaxCycle);  // speed leftDOWN/rightUP
  delay(10000); 
  carValues(carStop, carUnchanged, carStop, carUnchanged);  // set stop rotations left/right after n sec.
  carSpeed();  // stop rotations

}

void loop() {
  // TESTING [1] //
  carValues(carMinCycle, carForward, carMinCycle, carForward);
  carSpeedTo(carMinCycle, carMaxCycle);
  carValues(carStop, carUnchanged, carStop, carUnchanged);
  carSpeed();
  delay(5000);

  // TESTING [2] //
  carValues(carMinCycle, carForward, carMaxCycle, carReverse);
  carSpeedTo(carMinCycle, carMaxCycle);
  carValues(carStop, carUnchanged, carStop, carUnchanged);
  carSpeed();
  delay(5000);
}
