#include <sDateTimeSun.h>

void prntTime(sEpoch ep, char * s) {
  time_t t = ep.sec;  // use my "sDateTimeSun.h" library
  Serial.printf("  %s %02u-%02u-%04u %02u:%02u\n",
                 s, day(t), month(t), year(t), hour(t), minute(t));
  /** ouput 2021:
    Equinox and Solstice (UTC/GMT): 
      Equinox  spring 20-03-2021 09:37
      Solstice summer 21-06-2021 03:32
      Equinox  autumn 22-09-2021 19:21
      Solstice winter 21-12-2021 15:59
  **/
}
void setup() {
  Serial.begin(115200);
  while (!Serial); delay(1000);
  Serial.println("\n");
  sSetTz((char *)"GMT+0");  // zone (only if no other timezone in use)
  Serial.println("Equinox and Solstice (UTC/GMT): ");
  sEquiSol es = sCalcEquiSol(2021);
  prntTime(es.spring, (char *)"Equinox  spring");
  prntTime(es.summer, (char *)"Solstice summer");
  prntTime(es.autumn, (char *)"Equinox  autumn");
  prntTime(es.winter, (char *)"Solstice winter");  
}

void loop() {}
