/**  sESP32_WS_Clienter EXAMPLE with my sWiFi library
  *  Totally free to use and modify
  *  Ewald Kendziorra sr, 2023, www.kendziorra.nl     **/
//   **** Use it with the ESP32 or a other Server **** //
//    simpleLib WS server/client only for text data    //
// --------------------------------------------------- //

#define USE_STA        // use WiFi mode STA
#ifdef USE_STA         // only station mode
//  #define USE_STAIP    // if using a static STA IP (is needed with: USE_WS)
//  #define USE_STADNS   // use WiFi STA DNS
//  #define USE_STACHAN  // used in AP_STA mode
//  #define USE_OTA      // ArduinoOTA
//  #define USE_TIME     // NTP, date, time, timezone, DST/Summertime /** my simpleLIB library: sDateTimeSun.h       **/
//  #define USE_WS       // WebSockets Server         /**   // used library: https://github.com/me-no-dev/ESPAsyncWebServer and https://github.com/me-no-dev/AsyncTCP **/
  #define USE_WSCL     // ESP32 Websocket client (sSimpleLib)
//  #define USE_WTHR     // Weather, Sunrise, Sunset       /** sOpenweathermap.h **/
//  #define USE_SOLARMETEO  // KNMI SOLAR weersverwachting /** sSolarMeteo.h **/
#endif
//#define USE_AP         // use WiFi mode AP
#ifdef USE_AP          // only softAp mode
//  #define USE_APIP     // if using a static AP IP 
//  #define USE_APCHAN   // used in AP_STA mode
//  #define USE_APHID    // SSID hidden
//  #define USE_APMAXCON // max connections, default 4, max 10
//  #define USE_NOW      // ESP-NOW only in softAP mode
#endif
#if defined(USE_NOW) || defined(USE_WS)
//  #define USE_PARSER   // parse the received message to fieldnames an fieldValues 
#endif
#if defined(USE_STA) && defined(USE_AP) 
//  #define USE_LR       // ESP32 softAP Long Range mode up to 1000m (only in AP_STA mode)
#endif

#define USE_ESP32_SERVER
const char
      staSsid[] = "edit-edit"@,
  staPassword[] = "edit-edit"@;
#ifdef USE_ESP32_SERVER                       
  const char *ws_URI = "ws://192.168.178.141:82/myServer"@;  // the sESP32_WS_Server example
#else  // replace it with this format: "ws://ip1.ip2.ip3.ip4:port/protocol"
  const char *ws_URI = "ws://ws-postman.eu-gb.mybluemix.net:80/ws/echo";  // a extern TEST Websocket server
#endif

// after the above "used in sWiFiFull.h" declarations 
#include <sWiFiFull.h>  // sSimpleLib

void setup() {
  Serial.begin(115200);
  while (!Serial); delay(1000);
  Serial.println("\n");
  setupWiFi();  // is necessary on this place - init all your defined choices
  ws_Start();
  // ##### demo code #####
  Serial.println("\n##### Demo START #####");
  Serial.println("demo - Send: 0 to 9 and expect to receive it back.");
  Serial.printf("ws_Connected: %s\n", (ws_Connected ? "YES" : "NO"));
}

void loop() {
  loopWiFi();  // is necessary on this place

  // ##### demo code #####
  static time_t ms = millis();
  static uint8_t n = 0, t = 0;
  bool f;
  /**
    void ws_Start();           // start Client
    void ws_Stop();            // stop Client
    bool ws_Send(String str);  // send a data-String to the Websocket Server
    bool ws_Connected;         // this Client is connected?
    bool ws_Val;               // data received flag - there is data from the Websocket Server in the ws_Buf
    String ws_Buf;             // received data buffer - after read buffer then set ws_Val to false 
  **/
  if (ws_Val) {
    ws_Val = false;  // reset received flag
    Serial.printf("Received: %s\n", ws_Buf.c_str());  // do something with the data buffer
    t = 0;
  }
  if (ms <= millis()) { 
    f = ws_Send(String(n));
    if (!f) {
      ws_Stop();
      Serial.printf("ws_Connected: %s\n", (ws_Connected ? "YES" : "NO"));
      if (++t == 10) n = 11;  // stop test
      ws_Start();
      Serial.printf("ws_Connected: %s\n", (ws_Connected ? "YES" : "NO"));
    }
    else n++;
    ms = millis() + 1000;
  }
  if (n => 10) {
    ws_Stop();
    Serial.println("##### Demo END #####");
    while (1){}
  }
}
