#include <Wire.h>

const uint8_t sdaPin = 21,
              sclPin = 22;
/** interpolate and extrapolate temperatures offsets **/
// calibrate: ‪‬0*C(ice water) and 100*C(boiling water)
// temperature offset: 0*C,  100*C   (1*C is 1*K)
// calibrateAmbient0C = 0.0, calibrateAmbient100C = 0.0   // AMBIENT
// calibrateObject0C  = 0.0, calibrateObject100C  = 0.0   // OBJECT 
/** interpolate and extrapolate temperatures offsets **/
const float mlxCalibrate[2][2] = { {0.0, 0.0},            // AMBIENT   
                                   {0.0, 0.0} };          // OBJECT                
#include <sMLX90614.h>

void setup() {
  Serial.begin(115200);
  Wire.begin();
  Serial.print("\n...\n");
  Wire.begin(sdaPin, sclPin);
}

void loop() {
  float ambientMlx = sGetMlxTemp(mlxAmbient),
    objectMlx = sGetMlxTemp(mlxObject);
 Serial.printf("Ambient: %s*K, %s*C, %s*F  Objec:  %s*K, %s*C, %s*F\n\n",
    String(ambientMlx, 2).c_str(), String((ambientMlx - 273.15), 2).c_str(), String((ambientMlx * 9 / 5 - 459.67), 2).c_str(),
    String(objectMlx, 2).c_str(), String((objectMlx - 273.15), 2).c_str(), String((objectMlx * 9 / 5 - 459.67), 2).c_str());
  delay(5000);
}
