/** sSolarMeteo - leest "nu" en "morgen" weersverwachtingen per uur. 
  * Ewald Kendziorra sr, www.kendziorra.nl, 2023
  * totally free to use and modify, no support
  **/
/** ######################################################################## *
  * ##### EERST TE DOEN:                                               ##### *
  * #####  leesmij.txt lezen, anders kom je er niet ver mee            ##### *
  * #####  importeer mijn "simpleLib" library http://www.kendziorra.nl ##### *
  * ######################################################################## **/

#define USE_STA   // use WiFi mode STA
#define USE_TIME  // use date, time, sun
#define USE_SOLARMETEO
#define USE_TEST_STRING // "comment" dit als je gegevens van meteoserver.nl wil ophalen
                        // "ünComment" dit als je de TEST-gegevens wil gebruiken (meetlocatie Lelystad 26-12-2022 14:58)
/********** EDIT REGIO **********/
const char                                          
      *staSsid = "edit-edit"@,  // your SSID ...
  *staPassword = "edit-edit"@;  // ... and password
const String 
  PC = "0123AB"@,  // je postcode
  key = "a1b2c3d4"@;  // je meteoserver key (max. 500/maand gratis - totaal voor alle gebruikte diensten)
const double                       
  latSun = 52.1234,  // your latitude and longitude location (GPS) ...
  lonSun =  5.5678;  // ... to get the sun day-rise/set times in seconds
/** time ***** List of timezones https://sites.google.com/a/usapiens.com/opnode/time-zones **/
char timeZone[] = "CET-1CEST-2,M3.5.0/02:00:00,M10.5.0/03:00:00";  // EU Amsterdam/Barcelona with DST/Summertime
// char timeZone[] = "CET-1";       // EU Amsterdam/Barcelona - NO DST/Summertime 
const time_t syncTime = 12 * 3600;  // NTP time sync interval in sec. if 0 then NOT used
/********** EINDE EDIT ***********/

// ##### nu pas deze!
#include <sWiFiFull.h>    // always under the optional #define xyz declarations 

void setup() {
  Serial.begin(115200);
  while (!Serial) {;}
  delay(1000);
  Serial.println("\n");
  setupWiFi();  // is necessary on this place - init all your defined choices
  
  // ##### alleen voor demo op deze plaats - hint: automatisch dagelijks 00:15 uur of later de gegevens ophalen
  #ifdef USE_TEST_STRING 
    bool ok = decodeMeteo(true);  // met informatie in monitor
  #else
    bool ok = decodeMeteo(); // of decodeMeteo(true);  // zonder of met informatie in monitor
  #endif
  if (ok) {
    //............... doe er wat mee 
    //  enum {elev, az, temp, gr_w, gr, sd, tc, lc, mc, hc, vis, prec}  @@@@@@@@@@ LEES EERST leesmij.h @@@@@@@@@@
    //  enum {vandaag, morgen};
    //  tijden per uur: vanaf 00 t/m 23  (00:00 t/m 23:00)
    //  String weer[vandaag/morgen][elev,...,prec][00,....,23],  // als string, bij gebruik zelf zonodig omzetten naar type
    //  bruibare waarden:  
    //                    startTijd: download tijd
    //                    zonOpOn[0/1}: zom op/onder timestamp vanaf 00:00:00 uur 
    //                    vanaf: startuur waarden van "vandaag"
    //                 en weer[vandaag/morgen][elev,...,prec][00,....,23]: elev t/m prec als in leesmij.h en de meteoserver.nl PDF
    float straling = 0;
    for (uint8_t i = 0; i < 24; i++) straling += weer[morgen][gr][i].toFloat();
    straling = straling * 0.00277778;  // geeft de te verwachten totale instraling per vierkantemeter op een horizontaal vlak voor morgen
    Serial.printf("download van: %u (timestamp) - %02u-%02u-%02u %02u:%02u:%02u\n", startTijd, day(startTijd), 
                   month(startTijd), year(startTijd), hour(startTijd), minute(startTijd), second(startTijd));
    Serial.printf("vandaag zon op: %02u:%02u\n", hour(zonOpOn[0]), minute(zonOpOn[0]));
    Serial.printf("vandaag zon op: %02u:%02u\n", hour(zonOpOn[1]), minute(zonOpOn[1]));
    Serial.printf("vandaag vanaf: %u:00\n", vanaf);
    Serial.printf("temperatuur voor morgenmiddag 13:00 uur: %s*C\n", weer[morgen][temp][13]);
    Serial.printf("instraling morgen: %f kWh/m2\n", straling);
  }
  // ##### ----------------------------
}

void loop() {
  loopWiFi();  // is necessary on this place - connection 'stays alive' control
  // stop hier je toepassing in
}
