/** simple wheel decoder (change it in sWheelDecoder.h)
    uint8_t wheelDecoderPin[2] = {12, 13},                     // two wheel decoder Pins (wheelLeft = 0, wheelRight = 1)
            wheelDecoderSteps = 20;                            // number of wheelDecoder steps
    double wheelDia = 6.5,                                     // wheel diameter in cm
           gaugaDia = 12.0,                                    // wheel gauge in cm
           wheelOneStep =  PI * wheelDia / wheelDecoderSteps,  // wheel one step in cm
           gaugaOneDeg = PI * gaugaDia / 360.0;                // wheel gauge 1* turn in cm
    const uint8_t wheelLeft = 0, wheelRight = 1;               // (enum alternative)
    volatile uint16_t wheelPulse[2] = {0, 0};                  // puls counters (wheelLeft = 0, wheelRight = 1)
    
    void wheelBegin(uint8_t _wheelLeftPin, uint8_t _wheelRightPin, uint8_t _wheelDecoderSteps, double _wheelDia, double _gaugaDia);
    void wheelBegin();
    double wheelGoCm(double cm);
    double gaugaTurnDeg(double deg);
    void wheelLeftInt();
    void wheelRightInt();
 **/

#include <sSpeedDecoder.h>

void setup() {
  Serial.begin(115200);
  Serial.println("\n...\n");
  
  /** wheelBegin(_wheelLeftPin, _wheelRightPin, _wheelDecoderSteps, _wheelDia, _gaugaDia); **/
  // wheelBegin(12, 13, 20, 6.5, 12.0);
  wheelBegin();
  
  Serial.printf("wheelOneStep: %f cm, gaugaOneDeg: %f cm \n", wheelOneStep, gaugaOneDeg);
  Serial.printf("number of wheelDecoderSteps to go \n    25.0cm wheelGoCm(25.0): %f cm \n    one wheel turn 90* gaugaTurnDeg(90.0): %f cm \n        two wheel L+R-spin #step/2 \n", wheelGoCm(25.0),  gaugaTurnDeg(90.0)); 
}

void loop () {
  if (wheelPulse[wheelLeft] >= 10) {  // wheelLeft get pulses
    Serial.printf(" Left wheel pulses: %d, distance: %f cm \n", wheelPulse[wheelLeft], (wheelPulse[wheelLeft] * wheelOneStep));
    wheelPulse[wheelLeft] = 0;
  }
  if (wheelPulse[wheelRight] >= 15) {  // wheelRight get pulses
    Serial.printf("right wheel pulses: %d, distance: %f cm \n", wheelPulse[wheelRight], (wheelPulse[wheelRight] * wheelOneStep));
    wheelPulse[wheelRight] = 0;
  }
}
 
