/** 28YBJ-48 DC 5V 4 Phase 5 Wire Stepper Motor With ULN2003 Driver Board - 4096 steps **/

#include <sStepperSteps.h>

uint16_t stepPos,   // steps from HOME
         stepsEnd;  // number of steps from HOME to END

void setup() {
  Serial.begin(115200);
//  Serial.setDebugOutput(true); 
  Serial.println("\n...\n");

  sStepsInit(14,   // stepPin1, stepper pins on WeMos/NodeMCU/... 
             12,   // stepPin2
             13,   // stepPin3
             15,   // stepPin4
             16,   // homePin, microswitch HOME position
              0,   // (int16_t) nn>=0: endPin microswitch END or maximun number of rotations
                   //           nn<0: end position in steps (no END microswitch)
          false,   // stepper mode, false: 512 steps is 360*, true: 4096 steps is 360* 
              1,   // (uint8_t) stepper speed, delay in ms,  default 1, min: 1, max: 50
              2);  // (uint16_t) The maximun number of rotations to find the home/end position (1-65535)

  /** Result is ENDed on the maximun number of two rotations (NO ENDswich detected)
    *   If pin D3 (microswitch) detected then [nnn] stepsEnd
    *   With NO pin D3, but -12345 (example value) then: The last posible step is 12345 
    * stepsEnd:       1024  (The last posible step, two rotations of 512 steps mode, NO ENDswich detected)
    * stepPos:        0
    * gotoHome:       0
    * gotoEnd:        1024
    * stepper -255:   769
    * stepTo 111:     111
    * stepper +255:   366
    **/
  
  /** basic usage **/
  stepsEnd = _endPos;  // ENDswitch/ENDsteps or if ENDswitch NOT found position based on the maximun number of rotations 
  Serial.printf("stepsEnd: \t%d\n", stepsEnd);
  stepPos = stepPos;  // HOMEswitch or if HOMEswitch NOT found position based on the maximun number of rotations
  Serial.printf("stepPos: \t%d\n", stepPos);

  sGotoHome();    // find HOME position switch (using the maximun number of rotations)
  stepPos = stepPos;
  Serial.printf("gotoHome: \t%d\n", stepPos);
  
  sGotoEnd();     // find  END position switch (using the maximun number of rotations)
  stepPos = stepPos;
  Serial.printf("gotoEnd: \t%d\n", stepPos);
  
  stepper(-255);  // do n steps, 512 or 4096 steps is 360*
  stepPos = stepPos;
  Serial.printf("stepper -255: \t%d\n", stepPos);
  
  stepTo(111);  // go to step nn (from HOME), 512 or 4096 steps is 360*
  stepPos = stepPos;
  Serial.printf("stepTo 111: \t%d\n", stepPos);

  stepper(255);  // do n steps, 512 or 4096 steps is 360*
  stepPos = stepPos;
  Serial.printf("stepper +255: \t%d\n", stepPos);
}

void loop() {

}
