/**  sESP32_WS_Server EXAMPLE with my sWiFi library
  *  Totally free to use and modify
  *  Ewald Kendziorra sr, 2023, www.kendziorra.nl       **/
//   **** Use it with ESP32 and/or HTML Client(s) ****   //
//     simpleLib WS server/client only for text data     //
// ----------------------------------------------------- //

#define USE_STA        // use WiFi mode STA
#ifdef USE_STA         // only station mode
  #define USE_STAIP    // if using a static STA IP (is needed with: USE_WS)
//  #define USE_STADNS   // use WiFi STA DNS
//  #define USE_STACHAN  // used in AP_STA mode
//  #define USE_OTA      // ArduinoOTA
//  #define USE_TIME     // NTP, date, time, timezone, DST/Summertime /** my simpleLIB library: sDateTimeSun.h       **/
  #define USE_WS       // WebSockets Server         /**   // used library: https://github.com/me-no-dev/ESPAsyncWebServer and https://github.com/me-no-dev/AsyncTCP **/
//  #define USE_WSCL     // ESP32 Websocket client (sSimpleLib)
//  #define USE_WTHR     // Weather, Sunrise, Sunset                  /** sOpenweathermap.h **/
//  #define USE_SOLARMETEO  // KNMI SOLAR weersverwachting /** sSolarMeteo.h **/
#endif
//#define USE_AP         // use WiFi mode AP
#ifdef USE_AP          // only softAp mode
//  #define USE_APIP     // if using a static AP IP 
//  #define USE_APCHAN   // used in AP_STA mode
//  #define USE_APHID    // SSID hidden
//  #define USE_APMAXCON // max connections, default 4, max 10
//  #define USE_NOW      // ESP-NOW only in softAP mode
#endif
#if defined(USE_NOW) || defined(USE_WS)
//  #define USE_PARSER   // parse the received message to fieldnames an fieldValues 
#endif
#if defined(USE_STA) && defined(USE_AP) 
//  #define USE_LR       // ESP32 softAP Long Range mode up to 1000m (only in AP_STA mode)
#endif

const char
      staSsid[] = "edit-edit"@,
  staPassword[] = "edit-edit"@;
const IPAddress
        staIP(192, 168, 178, 141)@,  // IP also in HTML
  staGatewayIP(192, 168, 178,   1),
   staSubnetIP(255, 255, 255,   0);
const char wsURI[] = "/myServer"@;  // WebSocket URI, also in WS Client(s)
const uint16_t wsPort = 82@;  // used TCP Port, also in WS Client(s)

// after the above "used in sWiFiFull.h" declarations
#include <sWiFiFull.h>  // always under the optional #define xyz declarations

void wsAction();

void setup() {
  Serial.begin(115200);
  while (!Serial); delay(1000);
  Serial.println("\n");
  setupWiFi();  // is necessary on this place - init all your defined choices
}

void loop() {
  loopWiFi();  // is necessary on this place - connection 'stays alive' control
  if (wsVal) wsAction();  // WebSocket data received
  static uint8_t n = 0;
  static char c[21];
  static time_t t = millis();
  if (millis() > t) {
    t = millis();
    if (ws.count() > 0) {
      sprintf(c, "millis on Server: %u", t);
      ws.textAll(c);
    }
    t += 5000;
    ws.cleanupClients();
    ws.pingAll(NULL, 0);
  }
}

void wsAction() {
  Serial.printf("msg: %s\n", wsBuf.c_str());
  wsVal = false;
}
