#ifndef _S_ADS1115_H_
#define _S_ADS1115_H_

  #include <Wire.h>

  uint16_t maxStepsADS1115;
  const double voltStepADS1115 = 4.096 / 32767.0;
  double VddADS1115;
  uint8_t writeADS1115[2] = {0b11000010, 0b10000101},
          adressADS1115 =    0b1001000,
          portADS1115[4] =  {0b01000000, 0b01010000, 0b01100000, 0b01110000};
                                                     
  void sInitAds1115(double VddADS1115);
  uint16_t sAds1115(uint8_t);

  void sInitAds1115(double vdd) {
    VddADS1115 = vdd; 
    maxStepsADS1115 = VddADS1115 / voltStepADS1115;
  }

  uint16_t sAds1115(uint8_t p) {
    uint32_t steps = 0;
    uint8_t module = p / 4 + adressADS1115,
              port = p % 4;
    writeADS1115[0] = (writeADS1115[0] & 0b10001111) | portADS1115[port];
    Wire.beginTransmission(module);
    Wire.write(1);
    Wire.write(writeADS1115[0]);
    Wire.write(writeADS1115[1]);
    Wire.endTransmission();
    for (uint8_t i = 0; i < 3; i++) {
      delay(100);
      Wire.beginTransmission(module);
      Wire.write(0);
      Wire.endTransmission();
      delay(10);
      Wire.requestFrom(module, (uint8_t)2);
      steps += Wire.read() << 8 | Wire.read();
    }
    steps /= 3;
    return (steps > maxStepsADS1115 ? 0 : steps);
  }

#endif
