#ifndef SIMPLEDEGREES_H
#define SIMPLEDEGREES_H

#include "sStepperSteps.h"

bool toDegree(uint16_t);
bool findHome();
const uint16_t homePosDeg =   0;  // 270* - 6* -  stop +3* before min potentiometer angle (micro switch)
uint16_t endPosDeg =  264;  // 270* - 6* -  stop -3* before max potentiometer angle
double degPos = 0.0;  // current position in degrees
const double oneDegree = 1.422222222;  // (4096 / (8 * 360)) = 1.42... steps/degree
void sDegrees(uint8_t _stepPin1, uint8_t _stepPin2, uint8_t _stepPin3, uint8_t _stepPin4, uint8_t _homePin, uint16_t _endPos);
bool homeDetected = false;

void sDegrees(uint8_t _stepPin1, uint8_t _stepPin2, uint8_t _stepPin3, uint8_t _stepPin4, uint8_t _homePin, uint16_t _endPos) {
  sStepsInit(_stepPin1, _stepPin2, _stepPin3, _stepPin4, _homePin, -(_endPos), false, 1, 1);
  endPosDeg = _endPos;
  findHome();
}

bool findHome() {
  homeDetected = false;
  sGotoHome();
  if (_stepPos == 0) homeDetected = true;
  return homeDetected; 
}

/** turn to the requested position in degrees **/
bool toDegree(uint16_t deg) {
  if (!homeDetected || deg < homePosDeg || deg > endPosDeg) return false;
  if (deg == degPos) return true;
  double steps = deg * oneDegree - degPos * oneDegree;
  degPos = deg;
  stepper(steps);
  return true;  
}

#endif
