#ifndef _KAKU_H_
#define _KAKU_H_

//  KaKu, what does this means?
/** KaKu: 433MHz http://www.klikaanklikuit.nl/home/ modules.
 *    KaKu = Klik Aan Klik Uit
 *        translated
 *    CoCo = Click On Click Off
 *  You can use other brands!
 *  Kaku modules use the library from https://bitbucket.org/fuzzillogic/433mhzforarduino/wiki/Home 
 *  When using other brands you can easily change the libraries and receive/tramsmit code. 
 **/
 
#include <RemoteTransmitter.h>
#include <NewRemoteTransmitter.h>

enum {sOff, 
      sOn, 
      sDim
};

void sKaKuInit(uint8_t _pin, uint8_t _gndPin);
void sKakuOld(uint8_t _status, uint16_t _period, uint32_t _code);
void sKakuNew(uint8_t _status, uint16_t _period, uint32_t _address, bool _dimLevelPresent, uint8_t _dimLevel, uint8_t _unit, uint8_t _groupBit);
uint8_t sKakuPin, sOnPin; // sKakuPin:433MHz transmitter, sOnPin:LOW=PowerON/HIGH=PowerOFF(used as GND)

void sKaKuInit(uint8_t _pin, uint8_t _onPin) {
  sKakuPin = _pin;
  sOnPin = _onPin;
  pinMode(sOnPin, OUTPUT);
  digitalWrite(sOnPin, HIGH);
  pinMode(sKakuPin, OUTPUT);
}

/************** 
 *  KaKu OLD **
 **************/
void sKakuOld(uint8_t _status, uint16_t _period, uint32_t _code) {
  uint32_t cOn = _code,     // ON code
           cOff = cOn - 2;  // OFF code
  /** transmit **/
  digitalWrite(sOnPin, LOW);
  delay(50);  // start up time
  if (_status) {
    RemoteTransmitter::sendCode(sKakuPin, cOff, _period, 3);     // if ON then first OFF
    delay(100);
    RemoteTransmitter::sendCode(sKakuPin, cOn, _period, 3);      // ON
  }
  else RemoteTransmitter::sendCode(sKakuPin, cOff, _period, 3);  // OFF
  digitalWrite(sOnPin, HIGH);
}

/************** 
 *  KaKu NEW **
 **************/
void sKakuNew(uint8_t _status, uint16_t _period, uint32_t _address, bool _dimLevelPresent, uint8_t _dimLevel, uint8_t _unit, uint8_t _groupBit) {
  uint8_t f = _status;
  /** transmit **/
  digitalWrite(sOnPin, LOW);
  delay(50);  // start up time
  NewRemoteTransmitter transmitter(_address, sKakuPin, _period);
  if (f == sDim || (f == sOn && _dimLevelPresent)) {  // Dimmer signal transmit
    if (_groupBit) transmitter.sendGroupDim(_dimLevel);
    else transmitter.sendDim(_unit, _dimLevel);
  } 
  else { // On/Off signal transmit
    bool isOn = (f == sOn);
    if (_groupBit) transmitter.sendGroup(isOn);  // Send to the group
    else transmitter.sendUnit(_unit, isOn);  // Send to a single unit
  }
  digitalWrite(sOnPin, HIGH);
}

#endif
