#ifndef _LAT_LON_DIS_BEAR_H_
#define _LAT_LON_DIS_BEAR_H_

struct DIST_BEAR {
  double  distance;
  double  bearing;
  bool rad = false;  // true:rad, falsf:deg
  char    unit = 'K'; // unit: K(m), m(eter), M(ile), N(mile)
} distBear;
bool _rad = false;  // true:rad, false:deg
char _unit = 'K'; // unit: K(m), m(eter), M(ile), N(mile)
void setRadUnit(bool rad, char unit);
void getDistBear(double lat1, double lon1, double lat2, double lon2);

void setRadUnit(bool rad, char unit) {
  distBear.rad = rad;
  char str[] = {'K', 'm', 'M', 'N', unit};
  char c[] = {unit, '\0'};
  if (strcspn(str, c) < (strlen(str) - 2)) distBear.unit = unit;
}

//  from latitude/longitude: get bearing in deg/rad, get distance in Miles/Km/Nautical
void getDistBear(double lat1, double lon1, double lat2, double lon2) {
  double la1, lo1, la2, lo2, lt;
  la1 = lat1 * DEG_TO_RAD;
  lo1 = lon1 * DEG_TO_RAD;
  la2 = lat2 * DEG_TO_RAD;
  lo2 = lon2 * DEG_TO_RAD;
  lt = lo2 - lo1;
  distBear.bearing = atan2(sin(lt) * cos(la2), cos(la1) * sin(la2) - sin(la1) * cos(la2) * cos(lt));  //  Bearing
  if (!distBear.rad) distBear.bearing *= RAD_TO_DEG;
  distBear.distance = 6371.01 * acos( sin(la1) * sin(la2) + cos(la1) * cos(la2) * cos(lt));  //  distance
  switch(distBear.unit) {
    case 'K':  break;
    case 'm': distBear.distance *= 1000;break;
    case 'M': distBear.distance /= 1.609344;break;
    case 'N': distBear.distance *= 0.8684; break;
  }
}

#endif
