#define _LIVEMETEO_H_
#ifdef _LIVEMETEO_H_
  #include <HTTPClient.h>   // we moeten (meermaals dagelijks?) gegevens van een server halen

  #ifdef USE_TEST_STRING  
    String testLive = 
      "{\"liveweer\": [{\"plaats\": \"Dronten\","
      "\"temp\": \"5.9\", \"gtemp\": \"3.6\", \"samenv\": \"Zwaar bewolkt\", "
      "\"lv\": \"61\", \"windr\": \"ZW\", \"windrgr\": \"225\", \"windms\": \"3\", "
      "\"winds\": \"2\", \"windk\": \"5.8\", \"windkmh\": \"10.8\", \"luchtd\": \"1004.4\", "
      "\"ldmmhg\": \"753\", \"dauwp\": \"-2\", \"zicht\": \"50\", "
      "\"verw\": \"Vrij veel bewolking en enkele buien. Dinsdag regen en natte sneeuw\", "
      "\"sup\": \"07:10\", \"sunder\": \"18:25\", \"image\": \"zwaarbewolkt\", "
      "\"d0weer\": \"bewolkt\", \"d0tmax\": \"5\", \"d0tmin\": \"2\", \"d0windk\": \"3\", "
      "\"d0windknp\": \"10\", \"d0windms\": \"5\", \"d0windkmh\": \"19\", \"d0windr\": \"ZW\", "
      "\"d0windrgr\": \"225\", \"d0neerslag\": \"4\", \"d0zon\": \"3\", "
      "\"d1weer\": \"regen\", \"d1tmax\": \"4\", \"d1tmin\": \"3\", \"d1windk\": \"2\", "
      "\"d1windknp\": \"6\", \"d1windms\": \"3\", \"d1windkmh\": \"11\", \"d1windr\": \"W\", "
      "\"d1windrgr\": \"270\", \"d1neerslag\": \"90\", \"d1zon\": \"10\", "
      "\"d2weer\": \"halfbewolkt\", \"d2tmax\": \"4\", \"d2tmin\": \"-4\", \"d2windk\": \"2\", "
      "\"d2windknp\": \"6\", \"d2windms\": \"3\", \"d2windkmh\": \"11\", \"d2windr\": \"O\", "
      "\"d2windrgr\": \"90\", \"d2neerslag\": \"50\", \"d2zon\": \"20\", \"alarm\": \"0\", "
      "\"alarmtxt\": \"\"}]}";
  #endif

  enum {
    l_temp, l_lv, l_windr, l_winds, l_luchtd, l_dauwp, 
    l_zicht, l_d0weer, l_d0tmax, l_d0tmin, l_d0neerslag, l_d0zon};  // alleen wat gegevans over de afgelopen 10 munuten
  const String liveItems[l_d0zon + 1] = {
    "temp", "lv", "windr", "winds", "luchtd", "dauwp",
    "zicht", "d0weer", "d0tmax", "d0tmin", "d0neerslag", "d0zon"};
  String 
    dataLive, // data van server
    liveweer[l_d0zon + 1];  // opslaan als string, bij gebruik zelf zonodig omzetten naar type
  time_t startTijd = 0;  // UNIX timestamp - gebruik mijn simpleLib-sDateTimeSun.h)
  bool liveInfo;
  
  bool decodeLive(bool showInfo = false);  // showInfo: info to monitor
  bool weerLive();  

  bool decodeLive(bool showInfo) {  // showInfo: info to monitor
    liveInfo = showInfo;
    bool f = weerLive();  // gegevens ophalen

    if (f) {
      if (dataLive.lastIndexOf("\"alarmtxt\": \"") == -1) f = false;  // er is iets fout gegaan
      else {  // live weer gegevens uitpluizen
        int16_t p1, p2;
        String str1;
        dataLive = dataLive.substring(dataLive.indexOf("\"temp\": \""), dataLive.indexOf("\"d1weer\": \""));
        startTijd = now();  // UNIX timestamp inlees tijd
        // lijst vullen
        for (uint8_t i = 0; i <= l_d0zon; i++) {
          // "\"temp\": \"5.9\",  // zoek positie waarde
          //              ^
          str1 = "\"" + liveItems[i] + "\": \"";
          p1 = dataLive.indexOf(str1);
          if (p1 >=0) {
            p1 = p1 + str1.length();
            p2 = dataLive.indexOf("\", ", p1);
            liveweer[i] = dataLive.substring(p1, p2);
          }
          else liveweer[i] = "fout";
        }
      }
    }
    return f;
  }    

  bool weerLive() {
    bool f = true;
    #ifdef USE_TEST_STRING
      dataLive = testLive;
    #else    
      String url = "https://weerlive.nl/api/json-data-10min.php?" + liveKeyLatLon;
      if (liveInfo) Serial.println(url);
      if (!WiFi.isConnected()) {
        WiFi.begin();
        delay(500);
      }
      HTTPClient http;
      http.begin(url);
      int httpCode = http.GET();
      if (httpCode > 0) dataLive = http.getString();
      else f = false;
      http.end();
    #endif
    return f;
  }    

#endif