#ifndef _WHEEL_DECODER_H_
#define _WHEEL_DECODER_H_

uint8_t wheelDecoderPin[2] = {12, 13},                     // two wheel decoder Pins (wheelLeft = 0, wheelRight = 1)
        wheelDecoderSteps = 20;                            // number of wheelDecoder steps
double wheelDia = 6.5,                                     // wheel diameter in cm
       gaugaDia = 12.0,                                    // wheel gauge in cm
       wheelOneStep =  PI * wheelDia / wheelDecoderSteps,  // wheel one step in cm
       gaugaOneDeg = PI * gaugaDia / 360.0;                // wheel gauge 1* turn in cm
const uint8_t wheelLeft = 0, wheelRight = 1;               // (enum alternative)
volatile uint16_t wheelPulse[2] = {0, 0};                  // puls counters (wheelLeft = 0, wheelRight = 1)

void wheelBegin(uint8_t _wheelLeftPin, uint8_t _wheelRightPin, uint8_t _wheelDecoderSteps, double _wheelDia, double _gaugaDia);
void wheelBegin();
double wheelGoCm(double cm);
double gaugaTurnDeg(double deg);
void wheelLeftInt();
void wheelRightInt();

void wheelBegin(uint8_t _wheelLeftPin, uint8_t _wheelRightPin, uint8_t _wheelDecoderSteps, double _wheelDia, double _gaugaDia) {
  wheelDecoderPin[wheelLeft] = _wheelLeftPin;
  wheelDecoderPin[wheelRight] = _wheelRightPin;
  wheelDecoderSteps = _wheelDecoderSteps;
  wheelDia = _wheelDia;
  gaugaDia = _gaugaDia; 
  wheelOneStep =  PI * wheelDia / wheelDecoderSteps,  // wheel one step in cm
  gaugaOneDeg = PI * gaugaDia / 360.0;                // wheel gauge 1* turn in cm
  wheelBegin();
}

void wheelBegin() {
  attachInterrupt(digitalPinToInterrupt(wheelDecoderPin[wheelLeft]), wheelLeftInt, RISING );
  attachInterrupt(digitalPinToInterrupt(wheelDecoderPin[wheelRight]), wheelRightInt, RISING );
}

double wheelGoCm(double cm) {
  return cm / wheelOneStep;  // steps to go
}

double gaugaTurnDeg(double deg) {
  return deg * gaugaOneDeg / wheelOneStep;  // steps to turn
}

void wheelLeftInt() {
  wheelPulse[wheelLeft]++;
}

void wheelRightInt() {
  wheelPulse[wheelRight]++;
}

#endif
