#ifndef _TRANSMIT_433_H
#define _TRANSMIT_433_H

uint8_t txVPin, txPin, txPuls, txPRep, txRep, txI, txJ;
uint32_t txCode, txDB;
void txInit(uint8_t vccpin, uint8_t pin, uint8_t rep, uint8_t puls);
void txSend(char *str);
void txPulsIt(uint8_t d1, uint8_t d2);

void txInit(uint8_t vccPin, uint8_t pin, uint8_t rep, uint8_t puls) {
  txVPin = vccPin;
  pinMode(txVPin, OUTPUT);
  digitalWrite(txVPin, LOW);
  txPin = pin;
  pinMode(txPin, OUTPUT);
  txPuls = puls;
  txRep = rep;
}

void txSend(char *c) {
  uint8_t l = strlen(c);
  if (c[l] == '\n') l += 2;
  digitalWrite(txVPin, HIGH);
  delay(5);
  for (uint8_t i = 0; i <= l; i++) {
    txCode = (uint32_t) c[i];
    txPRep = txRep;
    txDB = 0;
    for (txI = 0; txI < 12; txI++) {
      txDB <<= 2;
      txDB |= (txCode % 3);
      txCode /= 3;
    }
    txPRep = 1 << (txPRep & B111);
    for (txI = 0; txI < txPRep; txI++) {
      txCode = txDB;
      for (txJ = 0; txJ < 12; txJ++) {
        switch (txCode & B11) {
          case 0: txPulsIt(1, 3); txPulsIt(1, 3); break;
          case 1: txPulsIt(3, 1); txPulsIt(3, 1); break;
          case 2: txPulsIt(1, 3); txPulsIt(3, 1); break;
        }
        txCode >>= 2;
      }
      txPulsIt(1, 31);
    }
  }
  digitalWrite(txVPin, LOW);
  delay(5);
}

void txPulsIt(uint8_t d1, uint8_t d2) {
  digitalWrite(txPin, HIGH);
  delayMicroseconds(txPuls * d1);
  digitalWrite(txPin, LOW);
  delayMicroseconds(txPuls * d2);
}

#endif
