#ifndef _S_WEATHERAPI_H_
  #define _S_WEATHERAPI_H_

  #include <WiFi.h>
  #include <HTTPClient.h>

  char url[120] = "https://www.weatherapi.com/weather/widget.ashx?loc=",
       url1[] = "&wid=1&tu=",
       url2[] = "&div=weatherapi-weather-widget-1";
  struct WAPI {
    char sky[60];
    char wspd[7];
    char prcp[6];
    char pres[7];
    char temp[8];
  } wapi;
  bool showInfo = false;  // info to monitor

  void weatherInit(char *_location, char *_units, bool _print = showInfo);
  bool getWeather();
  bool getWapi(String str);
 
  void weatherInit(char *_location, char *_units, bool _print) {
    showInfo = _print;
    sprintf(url + strlen(url), "%s%s%s%s", _location, url1, _units, url2);
    if (showInfo) Serial.println(url);
  }
  
  bool getWeather() {
    bool f = true;
    HTTPClient http;
    http.begin(url);
    int httpCode = http.GET();
    if (httpCode > 0) f = getWapi(http.getString());
    else f = false;
    http.end();
    return f;
  }    
  
  bool getWapi(String str) {
    bool f = false;
    if (showInfo) Serial.println(str);
    int16_t n1, n2;
    n1 = str.indexOf("weatherapi-weather-forecast ");
    if (n1 > 0) {
      str = str.substring(0, n1);  // remove redundant data at the end of the string
      n1 = str.indexOf("weatherapi_descr") + 19;
      if (n1 > 0) {
        str = str.substring(n1);
        n2 = str.indexOf("</span>");
        strcpy(wapi.sky, str.substring(0, n2).c_str());  // SKY
        n1 = str.indexOf("Wind: ") + 6;
        if (n1 > 0) {
          str = str.substring(n1);
          n2 = str.indexOf(" ");
          strcpy(wapi.wspd, str.substring(0, n2).c_str());  // WIND SPEED
          n1 = str.indexOf("Precip: ") + 8;
          if (n1 > 0) {
            str = str.substring(n1);
            n2 = str.indexOf(" ");
            strcpy(wapi.prcp, str.substring(0, n2).c_str());  // PRECIP
            n1 = str.indexOf("Pressure: ") + 10;
            if (n1 > 0) {
              str = str.substring(n1);
              n2 = str.indexOf(" ");
              strcpy(wapi.pres, str.substring(0, n2).c_str());  // PRESSURE
              n1 = str.indexOf("-temp") + 8;
              if (n1 > 0) {
                str = str.substring(n1);
                n2 = str.indexOf("<span>");
                strcpy(wapi.temp, str.substring(0, n2).c_str());  // TEMPERATURE
                f = true;
              }
            }
          }
        }
      }
    }
    return f;
  }
  
#endif
